# sb::Net
# == Author(s) : Takuya Otani <takuya.otani@gmail.com> ==
# == Copyright (C) 2005 SimpleBoxes/SerendipityNZ Ltd. ==

# ======================================
package sb::Net;
use strict;
use LWP::UserAgent;
use sb ();
use sb::Object ();
use base qw( sb::Object );
use vars qw( $VERSION );
$VERSION = '0.05';
# 0.05 [2007/11/29] added "agent" in member variables
# 0.04 [2007/08/09] fixed a simple syntax error in initialize
# 0.03 [2007/08/04] changed initialize
# 0.02 [2007/07/16] changed return to make them consistent
# 0.01 [2007/02/14] added initialize
# 0.00 [2005/10/09] created
# --------------------------------------
# // override base class
sub initialize
{
	my $self = shift;
	return $self->SUPER::initialize(
		'error' => undef,
		'agent' => undef,
		@_
	);
}
# --------------------------------------
# // public functions
sub error
{
	my $self = shift;
	$self->{'error'} = shift if (@_);
	return $self->{'error'};
}
sub agent
{ # get an instance of LWP::UserAgent
	my $self = shift;
	return $self->{'agent'} if ($self->{'agent'});
	my %param = (
		'proxy' => sb->get->conf->value('basic_http_proxy'),
		@_
	);
	my $ua = LWP::UserAgent->new;
	$ua->parse_head(0); # ignore to load HTML::Parser
	$ua->agent($self->agent_name);
	$ua->timeout(300);
	$ua->proxy('http'=>$param{'proxy'}) if ($param{'proxy'});
	$self->{'agent'} = $ua;
	return $self->{'agent'};
}
sub agent_name
{
	my $self = shift;
	return $sb::PRODUCT . '/' . $sb::VERSION;
}
1;
__END__
