/*!
  spica javascript libraries - style.js
  == written by Takuya Otani <takuya.otani@gmail.com> ===
  == Copyright (C) 2006 SimpleBoxes/SerendipityNZ Ltd. ==
*/

// [guideline]
// -- http://serennz.sakura.ne.jp/guidelines/js_en_000.txt
// -- http://serennz.sakura.ne.jp/guidelines/js_ja_000.txt

// ver 0.00 [2008/11/01] the first attempt

Spica.Style = function()
{
	this._style = {};
	return this;
}
Spica.Style.prototype = {
	set : function(elem,value)
	{
		this._style[this.camelize(elem)] = value;
		return true;
	},
	get : function(elem)
	{
		return this._style[elem];
	},
	getStyle : function()
	{
		return this._style;
	},
	importStyle : function(object)
	{
		var style = object.currentStyle || document.defaultView.getComputedStyle(object, '');
		if (!style) return false;
		var property = Spica.StyleProperties();
		for (var i=0,n=property.length;i<n;i++)
		{
			if (style[property[i]] != undefined)
				this._style[property[i]] = style[property[i]];
		}
		return true;
	},
	affect : function(object)
	{
		if (!object || !object.style) return;
		for (var elem in this._style)
		{
			object.style[elem] = this._style[elem];
		}
	},
	camelize : function(name)
	{
		if (!name.match(/-/)) return name;
		return name.replace(/-(\w)/g,function(str,chr) { return( chr.toUpperCase() ) });
	}
};
Spica.StyleProperties = function()
{
	// based on DOM level 2 CSS interface. http://www.w3.org/TR/DOM-Level-2-Style/css.html#CSS-CSS2Properties
	return [
		'azimuth',
		'background',
		'backgroundAttachment',
		'backgroundColor',
		'backgroundImage',
		'backgroundPosition',
		'backgroundRepeat',
		'border',
		'borderCollapse',
		'borderColor',
		'borderSpacing',
		'borderStyle',
		'borderTop',
		'borderRight',
		'borderBottom',
		'borderLeft',
		'borderTopColor',
		'borderRightColor',
		'borderBottomColor',
		'borderLeftColor',
		'borderTopStyle',
		'borderRightStyle',
		'borderBottomStyle',
		'borderLeftStyle',
		'borderTopWidth',
		'borderRightWidth',
		'borderBottomWidth',
		'borderLeftWidth',
		'borderWidth',
		'bottom',
		'captionSide',
		'clear',
		'clip',
		'color',
		'content',
		'counterIncrement',
		'counterReset',
		'cue',
		'cueAfter',
		'cueBefore',
		'cursor',
		'direction',
		'display',
		'elevation',
		'emptyCells',
		'cssFloat',
		'font',
		'fontFamily',
		'fontSize',
		'fontSizeAdjust',
		'fontStretch',
		'fontStyle',
		'fontVariant',
		'fontWeight',
		'height',
		'left',
		'letterSpacing',
		'lineHeight',
		'listStyle',
		'listStyleImage',
		'listStylePosition',
		'listStyleType',
		'margin',
		'marginTop',
		'marginRight',
		'marginBottom',
		'marginLeft',
		'markerOffset',
		'marks',
		'maxHeight',
		'maxWidth',
		'minHeight',
		'minWidth',
		'orphans',
		'outline',
		'outlineColor',
		'outlineStyle',
		'outlineWidth',
		'overflow',
		'padding',
		'paddingTop',
		'paddingRight',
		'paddingBottom',
		'paddingLeft',
		'page',
		'pageBreakAfter',
		'pageBreakBefore',
		'pageBreakInside',
		'pause',
		'pauseAfter',
		'pauseBefore',
		'pitch',
		'pitchRange',
		'playDuring',
		'position',
		'quotes',
		'richness',
		'right',
		'size',
		'speak',
		'speakHeader',
		'speakNumeral',
		'speakPunctuation',
		'speechRate',
		'stress',
		'tableLayout',
		'textAlign',
		'textDecoration',
		'textIndent',
		'textShadow',
		'textTransform',
		'top',
		'unicodeBidi',
		'verticalAlign',
		'visibility',
		'voiceFamily',
		'volume',
		'whiteSpace',
		'widows',
		'width',
		'wordSpacing',
		'zIndex'
	];
};
